<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!enabledUnits"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="form-item-container-local">
      <ob-selector
        v-model="formData.serviceTypeUuid"
        label="Тип услуги"
        :items="serviceTypes"
        value-exp="uuid"
        :disabled="disabledForm"
        display-exp="denomination"
        placeholder="Выберите"
      />
    </div>
    <div v-if="formData.serviceTypeUuid">
      <ob-input
        label="География"
        :value="SERVICE_GEOGRAPHY[formData.serviceGeography]"
        :disabled="true"
      />
      <div v-if="activeServiceType.need_resources">
        <table :class="{disabled: disabledForm}">
          <tr>
            <th>ТИП ресурса</th>
            <th>Подтип</th>
            <th>Шаблон</th>
          </tr>
          <tr v-if="!formData.resourceSpecies || formData.resourceSpecies.length === 0">
            <td colspan="3" class="not-data">Нет ресурсов</td>
          </tr>
          <spec
            v-for="(spec, index) in formData.resourceSpecies"
            :key="index"
            :spec="spec"
            :disabled-form="disabledForm"
          ></spec>
        </table>
      </div>
    </div>
    <div class="form-item-container-local">
      <ob-selector
        label="Возможные единицы измерения"
        v-model="formData.serviceUnits"
        :items="serviceMeasurementUnits"
        :value="[]"
        :disabled="!enabledUnits"
        display-exp="name"
        value-exp="name"
        placeholder="Выберите минимум одну"
        :is-multiselect="true"
        :is-dropdown="true"
        :is-tagbox="true"
      />
    </div>
  </ob-form>
</template>

<script>
import { SERVICE_GEOGRAPHY } from '@/resources/enum';
import FormValidationMixin   from 'common-components/src/obComponents/obForm/FormValidationMixin';
import Spec                  from './Spec';
import { uuid }              from 'vue-uuid';
import api                   from '@/api';
import cloneDeep             from 'clone-deep';
import models                from '@/models';
import ObForm                from 'common-components/src/obComponents/obForm';
import ObInput               from 'common-components/src/obComponents/obInput';
import ObSelector            from 'common-components/src/obComponents/obSelect';

export default {
  name: 'viewService',
  components: {
    ObForm,
    Spec,
    ObInput,
    ObSelector
  },
  mixins: [FormValidationMixin],
  props: {
    disabledForm: {
      type: Boolean,
      default: true
    },
    selectedData: {
      type: Object,
      required: true,
      default: () => {}
    },
    serviceTypes: {
      type: Array,
      required: true,
      default: () => []
    },
    serviceMeasurementUnits: {
      type: Array,
      required: true,
      default: () => []
    }
  },
  computed: {
    activeServiceType() {
      let _type = this.serviceTypes.find(type => {
        return type.uuid === this.formData.serviceTypeUuid;
      });
      return _type ? _type : {};
    },
    formModel() {
      return models.service.add;
    },
    isNew() {
      return !this.formData.uuid;
    },
    enabledUnits() {
      return (
        !this.dataSource.deleted_at || this.dataSource.deleted_at.length === 0
      );
    },
    dropdownMenu() {
      return this.isNew || this.dataSource.deleted_at
        ? null
        : [
            {
              title: 'Удалить',
              className: 'color-error',
              method: () => {
                this.$emit('delete');
              }
            }
          ];
    }
  },
  watch: {
    'formData.serviceTypeUuid'() {
      if (this.formData.serviceTypeUuid && this.dataSource.newStatus) {
        this.formData.serviceGeography = this.activeServiceType.service_geography;
        this.loadResourcesData().then(({ data }) => {
          this.formData.resourceSpecies = data;
        });
      }
    }
  },
  data() {
    return {
      SERVICE_GEOGRAPHY
    };
  },
  methods: {
    loadResourcesData() {
      let promises = [];
      let _data = [];
      return new Promise(resolve => {
        this.activeServiceType.resource_species.map(species => {
          promises.push(
            new Promise(resolve => {
              api.resources
                .getResourceSubTypes(species.uuid)
                .then(({ data }) => {
                  _data.push({
                    subTypes: data,
                    species: species,
                    resource_pattern: {},
                    subTypeUuid: '',
                    patternUuid: ''
                  });
                  resolve();
                })
                .catch(e => {
                  console.error(e);
                  this.$notification({
                    type: 'system_notification_error',
                    message: 'Ошибка загрузки данных'
                  });
                });
            })
          );
        });
        Promise.all(promises).then(() => {
          resolve({ data: _data });
        });
      });
    },
    onSubmitHandler() {
      let data = cloneDeep(this.formData);
      let method;
      if (this.isNew) {
        data = {
          uuid: uuid.v4(),
          services:
            this.formData.resourceSpecies.length > 0
              ? this.formData.resourceSpecies.map(spec => {
                  return {
                    service_type_uuid: this.formData.serviceTypeUuid,
                    resource_species_uuid: spec.species.uuid,
                    resource_sub_type_uuid: spec.subTypeUuid,
                    resource_pattern_uuid: spec.patternUuid
                  };
                })
              : [{ service_type_uuid: this.formData.serviceTypeUuid }],
          service_units: this.formData.serviceUnits
        };
        method = 'createService';
      } else {
        data = this.formData.serviceUnits;
        method = 'editService';
      }
      let notificationId = new Date().getTime() + 'save';
      this.$notification({
        type: 'system_notification_in_load',
        message: 'Сохранение',
        id: notificationId
      });
      api.services[method](data, this.formData.uuid)
        .then(() => {
          this.$emit('save');
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          });
        })
        .catch(e => {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          });
        })
        .finally(() => {
          this.$notification({ event: 'close', id: notificationId });
        });
    }
  }
};
</script>
